IMPLEMENTATION MODULE Disparos;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
IMPORT Lib,IO,Pantalla,Nave;
TYPE
		PT_disparo=POINTER TO T_disparo;
		T_disparo= RECORD
			   x:CARDINAL ;
			   y:CARDINAL ;
			   tipo:CHAR ;
			   sig_disparo:PT_disparo;			
		           END;

		TDISPARO=RECORD
				n_disparos:CARDINAL ;
				pdisparo:PT_disparo;
			END;
			
                DISPARO=POINTER TO TDISPARO;

PROCEDURE InicializarDisparo(VAR d:DISPARO);
BEGIN
        NEW(d);
	d^.n_disparos:=0;
	d^.pdisparo:=NIL;
END InicializarDisparo;

PROCEDURE Destruir (VAR d:DISPARO);
VAR
	pd,pd2:PT_disparo;
BEGIN
	pd:=d^.pdisparo;
	DISPOSE (d);
	WHILE pd#NIL DO
		pd2:=pd;
		pd:=pd^.sig_disparo;
		DISPOSE (pd2);
	END;
END Destruir;

(*Obtine las coordenadas del disparo q le digamos en el n*)
PROCEDURE ObtenerCoordenadasXY(d:DISPARO;VAR x,y:CARDINAL;n:CARDINAL);
VAR
	i:PT_disparo;
	n2:CARDINAL ;
BEGIN
	i:=d^.pdisparo;
	n2:=1;
		WHILE n2<n DO
			INC(n2);
			i:=i^.sig_disparo;
		END;
	x:=i^.x;
	y:=i^.y;
	
END ObtenerCoordenadasXY;

PROCEDURE ObtenerNumeroDisparos(d:DISPARO):CARDINAL;
BEGIN
	RETURN d^.n_disparos;
	
END ObtenerNumeroDisparos;

PROCEDURE CrearDisparo(VAR d:DISPARO;x,y:CARDINAL;tipo:CHAR);
VAR
	i:PT_disparo;
	k:CHAR;
   BEGIN
	INC(d^.n_disparos);
	NEW (i);
	i^.x:=x;
	i^.y:=y;
	i^.tipo:=tipo;
	i^.sig_disparo:=d^.pdisparo;
	d^.pdisparo:=i;

END CrearDisparo;

PROCEDURE Actualizar(N:Nave.NAVE;VAR D:DISPARO;VAR P:Pantalla.PANTALLA;VAR E:Enemigos.ENEMIGO):BOOLEAN;
VAR
	Mata_nave:BOOLEAN ;
	d,d2:PT_disparo;
	n_disparos,x,y,tipo:CARDINAL ;
	k:CHAR ;
BEGIN
	Mata_nave:=FALSE;
	(*Analiza disparos para eliminar los q no valgan*)
	WHILE ((D^.pdisparo#NIL) AND (Pantalla.Ocupado(D^.pdisparo^.x,D^.pdisparo^.y,P,D^.pdisparo^.tipo))) DO
		Pantalla.ColocarNada(D^.pdisparo^.x,D^.pdisparo^.y,P);
		CASE CAP(D^.pdisparo^.tipo) OF
		'D' : x:=D^.pdisparo^.x+1;
			Nave.DecrementaNumeroDisparos(N);
		|
		'I' : x:=D^.pdisparo^.x-1;
		END;		
		      y:=D^.pdisparo^.y;
		      d:=D^.pdisparo;
		      D^.pdisparo:=d^.sig_disparo;
		      DISPOSE (d);
		      CASE Pantalla.Obtener(x,y,P) OF
		      '2' :Enemigos.Eliminar(E,x,y);
		      |
		      '3': (*Disparo.Eliminar*)
		      |
		      CHR(16): Mata_nave:=TRUE ;
		      END;
		      Pantalla.ColocarExplosion(x,y,P);
	END;
	
	    d2:=D^.pdisparo;

		WHILE ((d2#NIL) AND (d2^.sig_disparo#NIL))  DO
			IF Pantalla.Ocupado(d2^.sig_disparo^.x,d2^.sig_disparo^.y,P,d2^.sig_disparo^.tipo) THEN
				Pantalla.ColocarNada(d2^.sig_disparo^.x,d2^.sig_disparo^.y,P);
				CASE CAP(d2^.sig_disparo^.tipo) OF
				'D' : x:=d2^.sig_disparo^.x+1;
				      Nave.DecrementaNumeroDisparos(N);
				|
				'I' : x:=d2^.sig_disparo^.x-1;
				END;		
				y:=d2^.sig_disparo^.y;
				d:=d2^.sig_disparo;
				d2^.sig_disparo:=d^.sig_disparo;
				DISPOSE (d);
				CASE Pantalla.Obtener(x,y,P) OF
				'2' :Enemigos.Eliminar(E,x,y);
				|
				'3': (*Disparo.Eliminar*)
				|
				CHR(16): Mata_nave:=TRUE ;
				END;
				Pantalla.ColocarExplosion(x,y,P);
			ELSE
			d2:=d2^.sig_disparo;
			END;
		END;
		
		(*Actualiza disparos*)
	d:=D^.pdisparo;
	WHILE d#NIL DO
                Pantalla.ColocarNada(d^.x,d^.y,P);
		CASE CAP(d^.tipo) OF
		'D': 
		     INC(d^.x);
		|
		'I': DEC(d^.x);
		END;
		Pantalla.ColocarDisparo(d^.x,d^.y,P);
		d:=d^.sig_disparo
	END;

					(*indica si salio de la pantalla y da por tipo 0 por la izq y 1 por la derecha*)
	WHILE ((D^.pdisparo#NIL) AND (Pantalla.FueraPantalla(P,D^.pdisparo^.x,tipo))) DO
		CASE tipo OF
		0: (*Enemigos.DecrementaDisparos*)
		|
		1: Nave.DecrementaNumeroDisparos(N);
		Pantalla.ColocarNada(D^.pdisparo^.x,D^.pdisparo^.y,P);
		END;
		d:=D^.pdisparo;
		D^.pdisparo:=d^.sig_disparo;
		DISPOSE (d);
	END;	
	d2:=D^.pdisparo;

		WHILE ((d2#NIL) AND (d2^.sig_disparo#NIL))  DO
			IF Pantalla.FueraPantalla(P,d2^.sig_disparo^.x,tipo) THEN
				CASE tipo OF
				0: (*Enemigos.DecrementaDisparos*)
				|
				1: Nave.DecrementaNumeroDisparos(N);
				Pantalla.ColocarNada(d2^.sig_disparo^.x,d2^.sig_disparo^.y,P);
				END;
				d:=d2^.sig_disparo;
				d2^.sig_disparo:=d^.sig_disparo;
				DISPOSE(d);
			ELSE 
				d2:=d2^.sig_disparo
			END;
		END;

	RETURN Mata_nave;
END Actualizar;
END Disparos.