IMPLEMENTATION MODULE Pantalla;
IMPORT IO,FIO,Lib,Window,Nave,Variable;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;

CONST
	Ancho_Pantalla=500;
	Alto_Pantalla=10;(*
        Archivo_GameOver='gameover.dat';
        Archivo_FinJuego='finjuego.dat';*)
TYPE
	T_Pantalla=RECORD
			p: ARRAY [0..Ancho_Pantalla],[0..Alto_Pantalla] OF CHAR ;
			inicio:CARDINAL ;
			fin:CARDINAL ;
		   END;
	PANTALLA=POINTER TO T_Pantalla;
        Cadena=ARRAY [0..12] OF CHAR ;

PROCEDURE CrearPantalla(VAR Pantalla:PANTALLA;Archivo:ARRAY OF CHAR;V:Variable.VARIABLES);
VAR
  x,y,completado,contador:CARDINAL;
  fichero:FIO.File;
  findelinea:CHAR;
BEGIN
	contador:=0;
	NEW (Pantalla);
	fichero:=FIO.Open(Archivo);
		FOR x:=0 TO Variable.Ancho_Pantalla(V) DO
			FOR y:=0 TO Variable.Alto_Pantalla(V)-1 DO
			INC(contador);completado:=((contador)DIV(Variable.Ancho_Pantalla(V)*Variable.Alto_Pantalla(V))*100);
			Window.GotoXY(32,40); IO.WrStr('Cargando Pantalla: ');
						IO.WrCard(completado,3);
						IO.WrStr(' %');
			Pantalla^.p[x][y]:=FIO.RdChar(fichero);
		END;
		findelinea:=FIO.RdChar(fichero);
		findelinea:=FIO.RdChar(fichero);
	END;
	Window.GotoXY(32,40); IO.WrStr('                        ');
	Pantalla^.inicio:=0;
	Pantalla^.fin:=35;
        FIO.Close(fichero);
END CrearPantalla;

PROCEDURE Destruir (P:PANTALLA);
BEGIN
	DISPOSE (P);
END Destruir;

PROCEDURE MostrarPantalla(VAR Pantalla:PANTALLA;V:Variable.VARIABLES);
VAR
	ancho,largo:CARDINAL ;
BEGIN
        Window.CursorOff;
	FOR ancho:=0 TO Variable.Alto_Pantalla(V)-1 DO
	        Window.GotoXY(25,ancho+9);
		FOR largo:=Pantalla^.inicio TO Pantalla^.fin DO
			CASE Pantalla^.p[largo][ancho] OF
			'0' :IO.WrChar(' ');
			|

			'1' :Window.TextColor(Window.Brown);
			     IO.WrChar('');
			     Window.TextColor(Window.White);
			|
			'2' :Window.TextColor(Window.LightGreen);
			     IO.WrChar('@');
			     Window.TextColor(Window.White);
			|
			'3' :Window.TextColor(Window.LightRed);
			     IO.WrChar('-');
			     Window.TextColor(Window.White);
			|
			'4' :Window.TextColor(Window.LightCyan);
			     IO.WrChar(CHR(16));
			     Window.TextColor(Window.White);
			|
			'5' :Window.TextColor(Window.LightRed);
			     IO.WrChar('*');
			     Window.TextColor(Window.White);
			     Pantalla^.p[largo][ancho]:='0';
			END;
		END;
	END;
	
END MostrarPantalla;

PROCEDURE ColocarExplosion(x,y:CARDINAL ;VAR P:PANTALLA);
BEGIN
	IF NOT Pantalla.Se_Sale(x,y,P)     THEN P^.p[x][y]:="5" END;	
	IF NOT Pantalla.Se_Sale(x+1,y,P)   THEN P^.p[x+1][y]:="5";END;
        P^.p[x-1][y]:="5";
	IF NOT Pantalla.Se_Sale(x,y+1,P)   THEN P^.p[x][y+1]:="5";END;
	IF ((y>0)AND  (NOT Pantalla.Se_Sale(x,y-1,P)))THEN P^.p[x][y-1]:="5";END;
	IF ((y>0)AND (NOT Pantalla.Se_Sale(x-1,y-1,P))) THEN P^.p[x-1][y-1]:="5";END;
	IF NOT Pantalla.Se_Sale(x-1,y+1,P) THEN P^.p[x-1][y+1]:="5";END;
	IF ((y>0)AND (NOT Pantalla.Se_Sale(x+1,y-1,P))) THEN P^.p[x+1][y-1]:="5";END;
	IF NOT Pantalla.Se_Sale(x+1,y+1,P) THEN P^.p[x+1][y+1]:="5";END;
	
END ColocarExplosion;

PROCEDURE ColocarNave(x,y:CARDINAL ;VAR P:PANTALLA);
BEGIN
	P^.p[x][y]:="4";
END ColocarNave;

PROCEDURE ColocarEnemigo(x,y:CARDINAL ;VAR P:PANTALLA);
BEGIN
	P^.p[x][y]:="2";
END ColocarEnemigo;

PROCEDURE ColocarDisparo(x,y:CARDINAL ;VAR P:PANTALLA);
VAR
BEGIN
	P^.p[x][y]:="3";
END ColocarDisparo;

PROCEDURE ColocarNada(x,y:CARDINAL ;VAR P:PANTALLA);
BEGIN
	P^.p[x][y]:="0";
END ColocarNada;

PROCEDURE Obtener(x,y:CARDINAL;P:PANTALLA):CHAR ;
BEGIN
    RETURN P^.p[x][y];
END Obtener;

PROCEDURE Se_Sale(x,y:CARDINAL;P:PANTALLA):BOOLEAN;
BEGIN
	RETURN ((x<=P^.inicio)OR (x>P^.fin)OR (y<0) OR (y>Alto_Pantalla-1))
END Se_Sale;


PROCEDURE FueraPantalla(P:PANTALLA;x:CARDINAL;VAR t:CARDINAL ):BOOLEAN;
VAR
	se_sale:BOOLEAN ;
BEGIN
	se_sale:=FALSE ;

	IF x<=P^.inicio THEN
		t:=0;
		se_sale:=TRUE;
	END;
	IF x>=P^.fin THEN
		t:=1;
		se_sale:=TRUE;
	END;
	RETURN se_sale;
END FueraPantalla;

PROCEDURE Ocupado(x,y:CARDINAL;P:PANTALLA;tipo:CHAR):BOOLEAN ;
VAR
	ocupado:BOOLEAN;
BEGIN
	CASE CAP(tipo) OF
             'C':	ocupado:=P^.p[x][y]#'0';
	     |
	     'D':	ocupado:=P^.p[x+1][y]#'0';
	     |
	     'I':	ocupado:=P^.p[x-1][y]#'0';
	END;
	RETURN ocupado;
END Ocupado;

PROCEDURE IncrementarPantalla(VAR P:PANTALLA;V:Variable.VARIABLES ):BOOLEAN;
VAR
   hay_pantalla:BOOLEAN ;
BEGIN
    hay_pantalla:=P^.fin<Variable.Ancho_Pantalla(V);
    IF hay_pantalla THEN
	INC(P^.inicio);
	INC(P^.fin);
    END;
    RETURN NOT hay_pantalla;
END IncrementarPantalla;

PROCEDURE MostrarRecuadroMenu();
BEGIN
        Window.TextColor(Window.LightGreen);
	Window.GotoXY(23,8); IO.WrStr('  ');
	Window.GotoXY(23,9); IO.WrStr(' ');   Window.GotoXY(61,9);IO.WrStr(' ');
	Window.GotoXY(23,10);IO.WrStr(' ');  Window.GotoXY(61,10);IO.WrStr(' ');
	Window.GotoXY(23,11);IO.WrStr(' ');  Window.GotoXY(61,11);IO.WrStr(' ');
	Window.GotoXY(23,12);IO.WrStr(' ');  Window.GotoXY(61,12);IO.WrStr(' ');
	Window.GotoXY(23,13);IO.WrStr(' ');  Window.GotoXY(61,13);IO.WrStr(' ');
	Window.GotoXY(23,14);IO.WrStr(' ');  Window.GotoXY(61,14);IO.WrStr(' ');
	Window.GotoXY(23,15);IO.WrStr(' ');  Window.GotoXY(61,15);IO.WrStr(' ');
	Window.GotoXY(23,16);IO.WrStr(' ');  Window.GotoXY(61,16);IO.WrStr(' ');
	Window.GotoXY(23,17);IO.WrStr(' ');  Window.GotoXY(61,17);IO.WrStr(' ');
	Window.GotoXY(23,18);IO.WrStr(' ');  Window.GotoXY(61,18);IO.WrStr(' ');
	Window.GotoXY(23,19);IO.WrStr('  ');
	Window.TextColor(Window.White);
END MostrarRecuadroMenu;

PROCEDURE MostrarTitulo();
BEGIN

        Window.TextColor(Window.LightRed);
        Window.GotoXY(35,5); IO.WrStr('    .oOOOo.    ');
	Window.GotoXY(35,6); IO.WrStr(' .oO G & F Oo. ');
	Window.GotoXY(35,7); IO.WrStr('  ');
END MostrarTitulo;

PROCEDURE MostrarPresentacion(Archivo:ARRAY OF CHAR);
VAR
        F:FIO.File;
	t:ARRAY [0..36]OF CHAR ;
	i:CARDINAL;
BEGIN
        (*Abre el archivo con la presentacion y lo muestra de forma ascendente*)
        (*entre las lineas 9 y 18*)
        t[0]:=CHR(13);
	F:=FIO.Open(Archivo);
	i:=0;
	FIO.RdStr(F,t);
	WHILE (NOT FIO.EOF) DO
		Window.GotoXY(25,9+i);
		IO.WrStr('                                    ');
                Window.GotoXY(25,9+i);		
		IO.WrStr(t);IO.WrLn;
		Lib.Delay (500);
		IF i<9 THEN
		   i:=i+1;
		ELSE
		   i:=0;
	        END;
	        FIO.RdStr(F,t);
        END;
        FIO.Close(F);	
END MostrarPresentacion;

PROCEDURE MostrarAutor();
BEGIN

        Window.TextColor(Window.White);
        Window.GotoXY(68,40); IO.WrStr('By Doverman.');
        Window.GotoXY(4,40);IO.WrStr('Francisco Snchez Madueo.');
END MostrarAutor;

PROCEDURE MostrarAbajoPantalla(text:ARRAY OF CHAR ;VAR FICH:ARRAY OF CHAR;VAR Num:CARDINAL;tipo:CHAR  );
VAR
	k:CHAR;
BEGIN

        Window.TextColor(Window.White);
        Window.GotoXY(20,22); IO.WrStr(text);IO.RdLn();
	IF tipo='C' THEN
		IO.RdStr(FICH);		
	ELSE 
		Num:=IO.RdCard();
	END;

	Window.GotoXY(20,22); IO.WrStr('                                                     ');

END MostrarAbajoPantalla;

PROCEDURE MostrarGameOver(V:Variable.VARIABLES);
VAR
        k:CHAR ;
        FICH:Cadena;
BEGIN
        Variable.Archivo_GameOver(V,FICH);
        MostrarPresentacion(FICH);
        Window.TextColor(Window.White);
END MostrarGameOver;

PROCEDURE MostrarFinJuego(V:Variable.VARIABLES);
VAR
        k:CHAR ;
        FICH:Cadena;
BEGIN
        Variable.Archivo_FinJuego(V,FICH);
        MostrarPresentacion(FICH);
        Window.TextColor(Window.White);
END MostrarFinJuego;

PROCEDURE MostrarMenuConVariables(V:Variable.VARIABLES);
VAR
	FICH:Cadena;
BEGIN
        Window.GotoXY(15,10);
	Variable.Archivo_Presentacion(V,FICH);
	IO.WrStr('1 .-Archivo de Presentacion :................. ');IO.WrStr(FICH);Window.GotoXY(15,11);
	Variable.Archivo_Menu(V,FICH);
	IO.WrStr('2 .-Archivo de Menu :......................... ');IO.WrStr(FICH);Window.GotoXY(15,12);
	Variable.Archivo_GameOver(V,FICH);
	IO.WrStr('3 .-Archivo de GameOver :..................... ');IO.WrStr(FICH);Window.GotoXY(15,13);
	Variable.Archivo_FinJuego(V,FICH);
	IO.WrStr('4 .-Archivo de Fin Juego :.................... ');IO.WrStr(FICH);Window.GotoXY(15,14);
	Variable.Archivo_Pantalla(V,FICH);
	IO.WrStr('5 .-Archivo de Pantalla :..................... ');IO.WrStr(FICH);Window.GotoXY(15,15);
	IO.WrStr('6 .-Maximo de disparos de nave en Pantalla :.. ');IO.WrCard(Variable.max_disparos(V),4);Window.GotoXY(15,16);
	IO.WrStr('7 .-Velocidad de Pantalla :................... ');IO.WrCard(Variable.velocidad(V),4);Window.GotoXY(15,17);
	IO.WrStr('8 .-Numero de Enemigos :...................... ');IO.WrCard(Variable.numero_enemigos(V),4);Window.GotoXY(15,18);
	IO.WrStr('S .-Ir al menu Anterior');Window.GotoXY(15,20);
	IO.WrStr('Pulse una opcion...');
END MostrarMenuConVariables;

PROCEDURE Fin();
BEGIN
    Window.Clear();
    Window.CursorOn;
    Window.TextColor(Window.White);IO.WrStr('Gracias por Jugar.');IO.WrLn();
    IO.WrStr('Agradezco la ayuda de mis amigos Testers :P');
    Window.TextColor(Window.Black);IO.WrStr('Gloria,Juan Jose, Toi, Juanmi.');IO.WrLn;
    Window.TextColor(Window.White);
    IO.WrStr('Email de contacto: Doverman@supercable.es');IO.WrLn;IO.WrLn;
    IO.WrStr('Si JuEgAs CoNtRa El MeJoR, PiErDe CoMo LoS dEmAs.');

END Fin;

END Pantalla.
